#!/usr/bin/env bash
#
# Skinny wrapper environment script for HEAP (run_heap.pl) under CSPP with singularity
#
# The location of the singularity container is required.
# So I am going to require CSPP_HEAP_HOME to find it.
#
# exit when the first non-zero exit status is encountered
set -e

# check installation home and chdir to it
if [[ -z $CSPP_HEAP_HOME ]]; then
  echo "Must provide CSPP_HEAP_HOME in environment. See cspp_heap_env.sh" 1>&2
  exit 1
fi

# check for singularity 
$CSPP_HEAP_HOME/scripts/sing_test.bash

# use readlink -f to track hidden links needed to grok bind string for singularity container of app
#readlinked=
#util=$CSPP_HEAP_HOME/util.sif
#dirlist=$(singularity --silent exec --home $PWD --bind $CSPP_HEAP_HOME $util Rscript $CSPP_HEAP_HOME/scripts/dirlist_heap.R $@)
#for mydir in $dirlist; do export readlinked=$readlinked,$(readlink -f $mydir); done
#bind=$(singularity --silent exec --home $PWD --bind $CSPP_HEAP_HOME $util Rscript $CSPP_HEAP_HOME/scripts/bind_wrangle.R $readlinked)
bind=$($CSPP_HEAP_HOME/scripts/bind_wrangle.bash $@)

# run run_heap.pl in the singularity container built for heap with grokked $bind
heap=$CSPP_HEAP_HOME/heap.sif
singularity --silent exec --home $PWD $bind $heap $CSPP_HEAP_HOME/scripts/run_heap.pl $@

# Done
echo Done.
